import * as React from "react";
import { Values } from "../utils/types";
import "./Badge.less";
export interface Props {
    children?: React.ReactNode;
    className?: string;
    superscript?: boolean;
    color?: Values<typeof Color>;
    size?: Values<typeof Size>;
}
export declare const cssClass: {
    CONTAINER: string;
    EMPTY: string;
    SUPER: string;
    color: (c: any) => string;
    size: (s: any) => string;
};
declare const Size: {
    readonly S: "s";
    readonly M: "m";
    readonly L: "l";
};
declare const Color: {
    readonly RED: "red";
    readonly BLUE: "blue";
    readonly GRAY: "gray";
};
export declare class Badge extends React.PureComponent<Props> {
    static defaultProps: {
        color: "blue";
        size: "m";
    };
    static Color: {
        readonly RED: "red";
        readonly BLUE: "blue";
        readonly GRAY: "gray";
    };
    static Size: {
        readonly S: "s";
        readonly M: "m";
        readonly L: "l";
    };
    render(): JSX.Element;
}
export {};
