"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var classnames = require("classnames");
var React = require("react");
var PropTypes = require("prop-types");
var react_datepicker_1 = require("react-datepicker");
require("./DatePicker.less");
function DatePicker(props) {
    return (React.createElement(react_datepicker_1.default, __assign({}, props, { inline: true, calendarClassName: classnames("DatePicker", props.className) })));
}
exports.default = DatePicker;
var dateType = PropTypes.oneOfType([
    PropTypes.instanceOf(Date),
    PropTypes.instanceOf(moment),
]);
DatePicker.propTypes = {
    className: PropTypes.string,
    // The following are the subset of react-datepicker props that this component supports.
    // More can be added here as needed.
    maxDate: dateType,
    minDate: dateType,
    onChange: PropTypes.func.isRequired,
    selected: dateType,
};
