import * as PropTypes from "prop-types";
import * as React from "react";
import { Props as ButtonProps } from "../Button/Button";
import { Props as TooltipProps } from "../Tooltip/Tooltip";
import "./EditableInfoPanel.less";
export interface Props {
    children: React.ReactNode;
    className?: string;
    title?: React.ReactNode;
    onClick: React.MouseEventHandler<HTMLButtonElement>;
    buttonProps?: ButtonProps;
    tooltipProps?: EditableInfoPanelTooltipProps;
}
export interface EditableInfoPanelTooltipProps extends Omit<TooltipProps, "children"> {
    children?: React.ReactNode | null;
}
export default class EditableInfoPanel extends React.PureComponent<Props> {
    static propTypes: {
        children: PropTypes.Validator<PropTypes.ReactNodeLike>;
        className: PropTypes.Requireable<string>;
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        onClick: PropTypes.Validator<(...args: any[]) => any>;
        buttonProps: PropTypes.Requireable<object>;
        tooltipProps: PropTypes.Requireable<object>;
    };
    render(): JSX.Element;
}
