"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cssClass = void 0;
var _ = require("lodash");
var classnames = require("classnames");
var React = require("react");
var PropTypes = require("prop-types");
var Size_1 = require("./Size");
require("../less/grid.less");
exports.cssClass = {
    COL: "Grid--Col",
};
function Col(_a) {
    var children = _a.children, className = _a.className, span = _a.span, Wrapper = _a.wrapperComponent, additionalProps = __rest(_a, ["children", "className", "span", "wrapperComponent"]);
    var colSpanClasses;
    if (typeof span === "number") {
        colSpanClasses = exports.cssClass.COL + "--" + Size_1.default.DEFAULT + "--" + span;
    }
    else {
        colSpanClasses = _.map(Size_1.default, function (s) { return span[s] && exports.cssClass.COL + "--" + s + "--" + span[s]; });
    }
    return (React.createElement(Wrapper, __assign({ className: classnames(exports.cssClass.COL, colSpanClasses, className) }, additionalProps), children));
}
exports.default = Col;
// Define the shape of the `span` prop as a map from viewport `Size` to the associated span length.
var colSpanPropShape = {};
_.forEach(Size_1.default, function (size) {
    colSpanPropShape[size] = PropTypes.number;
});
Col.propTypes = {
    children: PropTypes.node,
    className: PropTypes.string,
    span: PropTypes.oneOfType([PropTypes.number, PropTypes.shape(colSpanPropShape)]),
    wrapperComponent: PropTypes.any,
};
Col.defaultProps = {
    span: 1,
    wrapperComponent: "div",
};
