"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Grid = exports.cssClass = void 0;
var classnames = require("classnames");
var React = require("react");
var PropTypes = require("prop-types");
var Col_1 = require("./Col");
var MorePropTypes_1 = require("../utils/MorePropTypes");
var Row_1 = require("./Row");
var Size_1 = require("./Size");
require("../less/grid.less");
exports.cssClass = {
    GRID: "Grid",
};
exports.Grid = function Grid(_a) {
    var className = _a.className, children = _a.children, Wrapper = _a.wrapperComponent, additionalProps = __rest(_a, ["className", "children", "wrapperComponent"]);
    return (React.createElement(Wrapper, __assign({ className: classnames(exports.cssClass.GRID, className) }, additionalProps), children));
};
exports.Grid.Row = Row_1.default;
exports.Grid.Col = Col_1.default;
exports.Grid.Size = Size_1.default;
exports.Grid.propTypes = {
    children: MorePropTypes_1.default.oneOrManyOf(MorePropTypes_1.default.instanceOfComponent(Row_1.default)),
    className: PropTypes.string,
    wrapperComponent: PropTypes.any,
};
exports.Grid.defaultProps = {
    wrapperComponent: "div",
};
