import * as React from "react";
import { Values } from "../utils/types";
import "./Icon.less";
export interface Props {
    name: Values<typeof Icon.names>;
    size?: Values<typeof Icon.sizes>;
    className?: string;
}
interface IconComponent extends React.FunctionComponent<Props> {
    names: typeof names;
    sizes: typeof sizes;
}
export declare const cssClass: {
    CONTAINER: string;
    size: (size: any) => string;
};
export declare const Icon: IconComponent;
declare const names: {
    readonly BLOCKS: "blocks";
    readonly BOOK: "book";
    readonly BULLSEYE: "bullseye";
    readonly CAMERA: "camera";
    readonly CHART: "chart";
    readonly CHAT: "chat";
    readonly CHAT_HEART: "chat-heart";
    readonly CHECKMARK: "checkmark";
    readonly CIRCLE_C: "circle-c";
    readonly CLEVER_ACADEMY: "clever-academy";
    readonly CLOCK: "clock";
    readonly CLOSE_FLOATING_BUTTON: "close-floating-button";
    readonly DIPLOMA: "diploma";
    readonly FUNNEL: "funnel";
    readonly GEAR: "gear";
    readonly GLASSES: "glasses";
    readonly GLUE: "glue";
    readonly GRAPH: "graph";
    readonly HAND_CLICK: "hand-click";
    readonly HANDSHAKE: "handshake";
    readonly HEADSET: "headset";
    readonly JUGGLER: "juggler";
    readonly LEADER: "leader";
    readonly LIGHTNING_JAR: "lightning-jar";
    readonly LOCK: "lock";
    readonly MAP: "map";
    readonly MAGIC_LAMP: "magic-lamp";
    readonly MAGNIFY_C: "magnify-c";
    readonly MAGNIFY_USER: "magnify-user";
    readonly MAN: "man";
    readonly MENU: "menu";
    readonly MICROPHONE: "microphone";
    readonly MICROSCOPE: "microscope";
    readonly MOBILE_APPS: "mobile-apps";
    readonly NO_ENTRY: "no-entry";
    readonly ORIGAMI: "origami";
    readonly PAPER: "paper";
    readonly PEN: "pen";
    readonly PEN_PAPER: "pen-paper";
    readonly PHONE: "phone";
    readonly PHONE_SYNC: "phone-sync";
    readonly PICKAX: "pickax";
    readonly PLAY_BUTTON: "play";
    readonly PORTAL_OPEN: "portal-open";
    readonly PRESENT_GIFT: "present-gift";
    readonly PRESENTATION: "presentation";
    readonly PRINTER: "printer";
    readonly QR: "qr";
    readonly RIBBON_AWARD: "ribbon-award";
    readonly SCHOOL: "school";
    readonly SERVER: "server";
    readonly SHIELD: "shield";
    readonly SHOPPING_CART: "shopping-cart";
    readonly SMILEY_FACE: "smiley-face";
    readonly SQUARE_C: "square-c";
    readonly SYNC_ARROWS: "sync-arrows";
    readonly TABLET: "tablet";
    readonly TARGET: "target";
    readonly THREE_PEOPLE: "three-people";
    readonly THREE_USERS: "three-users";
    readonly TICKET: "ticket";
    readonly TIE: "tie";
    readonly TROPHY: "trophy";
    readonly TYPEWRITER: "typewriter";
    readonly USER: "user";
    readonly WALLET: "wallet";
    readonly WEBSITE_DASHBOARD: "website-dashboard";
    readonly WEBSITE_HTML: "website-html";
    readonly WOMAN: "woman";
};
declare const sizes: {
    readonly XXS: "2xs";
    readonly XS: "xs";
    readonly SMALL: "small";
    readonly MEDIUM: "medium";
    readonly LARGE: "large";
};
export {};
