import * as React from "react";
import * as PropTypes from "prop-types";
import "./InfoPanel.less";
export interface Props {
    children?: React.ReactNode;
    className?: string;
    title?: React.ReactNode;
    hideTitle?: boolean;
    footer?: React.ReactNode;
    collapsible?: boolean;
    defaultOpen?: boolean;
}
interface State {
    isCollapsed: boolean;
}
export declare const cssClass: {
    CONTAINER: string;
    FOOTER: string;
    TITLE: string;
    HEADER: string;
    CONTENT: string;
    COLLAPSE_ARROW: string;
    COLLAPSIBLE_TITLE: string;
    COLLAPSIBLE_HEADER: string;
};
/**
 * Base presentational component for the displaying information in paneled format.
 */
export default class InfoPanel extends React.Component<Props, State> {
    static propTypes: {
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        className: PropTypes.Requireable<string>;
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        hideTitle: PropTypes.Requireable<boolean>;
        footer: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        collapsible: PropTypes.Requireable<boolean>;
        defaultOpen: PropTypes.Requireable<boolean>;
    };
    constructor(props: Props);
    toggleArrow(keys: any): void;
    render(): JSX.Element;
}
export {};
