import * as PropTypes from "prop-types";
import * as React from "react";
import "./NavLink.less";
export interface Props {
    className?: string;
    component?: any;
    [additionalProp: string]: any;
    href?: string;
    icon?: React.ReactElement;
    label?: React.ReactNode;
    title?: string;
    onClick?: React.MouseEventHandler;
    selected?: boolean;
    _collapsed?: boolean;
    _withArrow?: boolean;
    _withTooltips?: boolean;
}
export declare const cssClass: {
    ARROW_CONTAINER: string;
    ARROW_ICON: string;
    COLLAPSED: string;
    CONTAINER: string;
    CONTENTS: string;
    ICON: string;
    ICON_CONTAINER: string;
    LABEL: string;
    LABEL_CONTAINER: string;
    SELECTED: string;
    WITH_ARROW: string;
};
export declare class NavLink extends React.PureComponent<Props> {
    static propTypes: {
        className: PropTypes.Requireable<string>;
        component: PropTypes.Requireable<any>;
        href: PropTypes.Requireable<string>;
        icon: PropTypes.Requireable<PropTypes.ReactElementLike>;
        label: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        title: PropTypes.Requireable<string>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        selected: PropTypes.Requireable<boolean>;
        _collapsed: PropTypes.Requireable<boolean>;
        _withArrow: PropTypes.Requireable<boolean>;
        _withTooltips: PropTypes.Requireable<boolean>;
    };
    render(): JSX.Element;
}
