import * as PropTypes from "prop-types";
import * as React from "react";
import Item from "./Item";
import { ChildrenOf } from "../utils/types";
import "./List.less";
export interface Props {
    children?: ChildrenOf<typeof Item>;
    className?: string;
    itemsClassName?: string;
    emptyMessage?: React.ReactNode;
    noBorder?: boolean;
    rowType?: "plain" | "bordered" | "zebra";
    title?: React.ReactNode;
}
export default class List extends React.PureComponent<Props> {
    static propTypes: {
        children: PropTypes.Requireable<any>;
        className: PropTypes.Requireable<string>;
        itemsClassName: PropTypes.Requireable<string>;
        emptyMessage: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        noBorder: PropTypes.Requireable<boolean>;
        rowType: PropTypes.Requireable<string>;
        title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    };
    static defaultProps: {
        rowType: string;
        emptyMessage: JSX.Element;
    };
    static Item: typeof Item;
    static RowType: {
        PLAIN: string;
        BORDERED: string;
        ZEBRA: string;
    };
    render(): JSX.Element;
}
