import * as React from "react";
import * as PropTypes from "prop-types";
export interface Props {
    children?: number | string;
    className?: string;
    short?: boolean;
}
export declare const cssClass: {
    CONTAINER: string;
};
/**
 * Provides consistent number formatting for long numbers (e.g. 4123456 -> 4,123,456), with optional
 * shortening (e.g. 4123456 -> 4.1M).
 */
export default class Number extends React.PureComponent<Props> {
    static propTypes: {
        children: PropTypes.Requireable<string | number>;
        className: PropTypes.Requireable<string>;
        short: PropTypes.Requireable<boolean>;
    };
    static format(num: number | string, short?: boolean): any;
    render(): JSX.Element;
}
