import * as PropTypes from "prop-types";
import * as React from "react";
import "./ProgressBar.less";
export interface Props {
    color?: string;
    fill?: number;
    size?: string;
    striped?: boolean;
    className?: string;
    inactive?: boolean;
    label?: string;
    labelType?: React.ReactNode;
    percentage?: number;
    showLabel?: string;
    style?: React.CSSProperties;
    width?: string | number;
    markNumbers?: number[];
}
export default class ProgressBar extends React.PureComponent<Props> {
    static propTypes: {
        className: PropTypes.Requireable<string>;
        style: PropTypes.Requireable<object>;
        fill: PropTypes.Requireable<number>;
        color: PropTypes.Requireable<string>;
        label: PropTypes.Requireable<string>;
        width: PropTypes.Requireable<number>;
        striped: PropTypes.Requireable<boolean>;
        inactive: PropTypes.Requireable<boolean>;
        showLabel: PropTypes.Requireable<string>;
        labelType: PropTypes.Requireable<string>;
        markNumbers: PropTypes.Requireable<any[]>;
    };
    static defaultProps: {
        size: string;
        color: string;
        width: number;
        fill: number;
        labelType: string;
    };
    render(): JSX.Element;
    _maybeTopLabel: () => JSX.Element;
    _maybeBottomLabel: () => JSX.Element;
    _getLabel: () => {};
}
