import * as React from "react";
import Tab from "./Tab";
import { Justify } from "../flex";
import { ChildrenOf, Values } from "../utils/types";
import "./TabBar.less";
export interface Props {
    children?: ChildrenOf<typeof Tab>;
    className?: string;
    justify?: Values<typeof Justify>;
    size?: Values<typeof TabBar.Size>;
}
interface TabBarComponent extends React.FunctionComponent<Props> {
    Size: typeof Size;
    Tab: typeof Tab;
}
export declare const cssClass: {
    CONTAINER: string;
    size: (s: any) => string;
};
declare const TabBar: TabBarComponent;
declare const Size: {
    readonly SMALL: "small";
    readonly MEDIUM: "medium";
    readonly LARGE: "large";
};
export default TabBar;
