import * as React from "react";
import * as PropTypes from "prop-types";
import "./HeaderCell.less";
export interface Props {
    className?: string;
    children?: React.ReactNode;
    onSortChange?: Function;
    sortable?: boolean;
    activeSortDirection?: "asc" | "desc";
    width?: string;
}
export declare const cssClass: {
    CONTENT: string;
    HEADER_CELL: string;
    LABEL: string;
    SORTABLE: string;
    SORT: string;
};
declare function HeaderCell({ children, className, onSortChange, sortable, activeSortDirection, width, }: Props): JSX.Element;
declare namespace HeaderCell {
    var propTypes: {
        className: PropTypes.Requireable<string>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        onSortChange: PropTypes.Requireable<(...args: any[]) => any>;
        sortable: PropTypes.Requireable<boolean>;
        activeSortDirection: PropTypes.Requireable<"desc" | "asc">;
        width: PropTypes.Requireable<string>;
    };
}
export default HeaderCell;
