"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cssClass = void 0;
var classnames = require("classnames");
var React = require("react");
var PropTypes = require("prop-types");
var tablePropTypes = require("./tablePropTypes");
var sortDirection_1 = require("./sortDirection");
var WIDTH = 7;
var HEIGHT = 12;
exports.cssClass = {
    ACTIVE: "Table--sort_icons--direction--active",
    ASCENDING: "Table--sort_icons--direction--ascending",
    CONTAINER: "Table--sort_icons",
    DESCENDING: "Table--sort_icons--direction--descending",
    DIRECTION: "Table--sort_icons--direction",
};
function SortIcons(_a) {
    var direction = _a.direction, className = _a.className, scale = _a.scale;
    return (React.createElement("svg", { className: classnames(exports.cssClass.CONTAINER, className), width: WIDTH * scale, height: HEIGHT * scale, viewBox: "0 0 " + WIDTH + " " + HEIGHT },
        React.createElement("polygon", { className: classnames(exports.cssClass.DIRECTION, exports.cssClass.ASCENDING, direction === sortDirection_1.default.ASCENDING && exports.cssClass.ACTIVE), points: "3.5 0 7 5 0 5" }),
        React.createElement("polygon", { className: classnames(exports.cssClass.DIRECTION, exports.cssClass.DESCENDING, direction === sortDirection_1.default.DESCENDING && exports.cssClass.ACTIVE), points: "3.5 12 7 7 0 7" })));
}
exports.default = SortIcons;
SortIcons.propTypes = {
    direction: tablePropTypes.sortDirection,
    className: PropTypes.string,
    scale: PropTypes.number,
};
SortIcons.defaultProps = {
    scale: 1,
};
