import * as React from "react";
import { ActionProps } from "./ToastNotification";
import { ToastNotificationType } from "./ToastType";
import "./ToastStack.less";
export interface ToastNotificationData {
    action?: ActionProps;
    content: React.ReactNode;
    durationMS?: number;
    id: number;
    showCloseButton?: boolean;
    type: ToastNotificationType;
    closeButtonAriaLabel?: string;
}
export interface Props {
    className?: string;
    clearNotification: (id: number) => void;
    defaultNotificationDurationMS?: number;
    notificationClassName?: string;
    notifications?: ToastNotificationData[];
}
/**
 * Toast notifications can be used to provide feedback in response to user interaction. The
 * <ToastStack> renders toast notifications and handles their enter/leave animations.
 */
export declare class ToastStack extends React.PureComponent<Props> {
    static defaultProps: {
        defaultNotificationDurationMS: number;
    };
    _finiteDuration(notification: any): boolean;
    componentDidUpdate(prevProps: any): void;
    render(): JSX.Element;
}
