import * as React from "react";
import { TopBarButton } from "./TopBarButton";
import "./index.less";
export declare const TopBarThemes: readonly ["default", "plain", "a11y"];
declare type TopBarTheme = typeof TopBarThemes[number];
export interface Props {
    children?: React.ReactNode;
    className?: string;
    logoAriaLabel?: string;
    logoHref: string;
    title?: React.ReactNode;
    customLogo?: React.ReactNode;
    onLogoClick?: Function;
    theme?: TopBarTheme;
}
/**
 * Global page-level header component.
 */
export declare class TopBar extends React.PureComponent<Props> {
    static defaultProps: Pick<Props, "theme" | "logoAriaLabel">;
    static Button: typeof TopBarButton;
    render(): JSX.Element;
}
export {};
