import * as React from "react";
import * as PropTypes from "prop-types";
export interface Props {
    title: string;
    stepNumberInTitle: boolean;
    description?: React.ReactNode;
    help?: React.ReactNode;
    Component: React.ComponentType<any>;
    componentProps?: any;
    className?: string;
    currentStep: number;
    totalSteps: number;
    updatePercentComplete: Function;
    calculatePercentComplete: Function;
    percentComplete: number;
    setWizardState: Function;
    validate?: (data: any) => boolean;
    wizardState: any;
}
interface State {
    collapseBreakpointWidth: number;
    helpTextCollapsed: boolean;
    renderedStepWidth: number;
}
export default class WizardStep extends React.Component<Props, State> {
    static propTypes: {
        title: PropTypes.Validator<string>;
        stepNumberInTitle: PropTypes.Validator<boolean>;
        description: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        help: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        Component: PropTypes.Validator<((...args: any[]) => any) | React.Component<unknown, unknown, unknown>>;
        componentProps: PropTypes.Requireable<object>;
        className: PropTypes.Requireable<string>;
        currentStep: PropTypes.Validator<number>;
        totalSteps: PropTypes.Validator<number>;
        updatePercentComplete: PropTypes.Validator<(...args: any[]) => any>;
        calculatePercentComplete: PropTypes.Validator<(...args: any[]) => any>;
        percentComplete: PropTypes.Validator<number>;
        setWizardState: PropTypes.Validator<(...args: any[]) => any>;
        wizardState: PropTypes.Validator<object>;
    };
    constructor(props: Props);
    componentDidMount(): void;
    componentWillUnmount(): void;
    private component;
    updateDimensions(): void;
    render(): JSX.Element;
}
export {};
