import * as React from "react";
import { AttachmentFileType } from "../MessagingAttachment/MessagingAttachment";
import "./AttachmentPreview.less";
export interface Props {
    attachmentName: string;
    attachmentURL: string;
    className?: string;
    closeButtonAriaLabel?: string;
    downloadButtonTextDesktop?: string;
    downloadButtonTextMobile?: string;
    fileType: AttachmentFileType;
    onClickDownload: () => void;
    onClose: () => void;
}
export declare const cssClass: {
    CONTAINER: string;
    BACKGROUND: string;
    HEADER_BAR: string;
    FILE_ICON: string;
    ATTACHMENT_NAME: string;
    DOWNLOAD_CONTAINER: string;
    DOWNLOAD_BUTTON: string;
    CLOSE_CONTAINER: string;
    CLOSE_BUTTON: string;
    PREVIEW_WINDOW: string;
    IMAGE_CONTAINER: string;
    ERROR_CONTAINER: string;
    ERROR_ICON: string;
    FOOTER_BAR: string;
};
/**
 * A full page preview for messaging attachments.
 * Currently only used for images, but eventually will be used for PDFs and other attachment types.
 */
export declare const AttachmentPreview: React.FC<Props>;
