import * as PropTypes from "prop-types";
import * as React from "react";
import "./CopyContainer.less";
export interface Props {
    children?: React.ReactNode;
    copyText?: string;
    buttonLabel?: string;
    className?: string;
    buttonType?: "linkPlain" | "primary" | "secondary";
    onCopyClick?: () => void;
}
interface State {
    copied: boolean;
}
export declare const cssClass: {
    CONTAINER: string;
    BUTTON: string;
};
/**
 * This component is useful when you want to make some text copyable.
 * It wraps the CopyToClipboard component.
 */
export default class CopyContainer extends React.PureComponent<Props, State> {
    static propTypes: {
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        copyText: PropTypes.Requireable<string>;
        buttonLabel: PropTypes.Requireable<string>;
        className: PropTypes.Requireable<string>;
        onCopyClick: PropTypes.Requireable<(...args: any[]) => any>;
    };
    constructor(props: Props);
    _onCopy(): void;
    render(): JSX.Element;
}
export {};
