import * as React from "react";
import * as PropTypes from "prop-types";
import { Button } from "../Button/Button";
import { Type } from "./Type";
import { Values } from "../utils/types";
import "./Menu.less";
export interface Props {
    children?: React.ReactNode;
    className?: string;
    onHide: () => void;
    size?: Values<typeof Button.Size>;
    type?: Values<typeof Type>;
}
export declare const cssClass: {
    CONTAINER: string;
    OPTION: string;
    WHITE_BACKGROUND: string;
};
export default class Menu extends React.PureComponent<Props> {
    static propTypes: {
        children: PropTypes.Requireable<any>;
        className: PropTypes.Requireable<string>;
        onHide: PropTypes.Validator<(...args: any[]) => any>;
        size: PropTypes.Requireable<Values<{
            readonly S: "small";
            readonly M: "regular";
            readonly L: "large";
        }>>;
        type: PropTypes.Requireable<Values<{
            readonly PRIMARY: "primary";
            readonly SECONDARY: "secondary";
            readonly DESTRUCTIVE: "destructive";
            readonly LINK: "link";
        }>>;
    };
    _renderOption(option: any): JSX.Element;
    render(): JSX.Element;
}
