import * as PropTypes from "prop-types";
import * as React from "react";
import "./GoalsLogo.less";
export interface BaseProps {
    className?: string;
}
interface ExtendedProps extends BaseProps {
    size?: "small" | "medium" | "large" | "custom";
    withClever?: boolean;
}
/**
 * Brand logo for the Clever Goals product.
 */
export default class GoalsLogo extends React.PureComponent<ExtendedProps> {
    static propTypes: {
        className: PropTypes.Requireable<string>;
        size: PropTypes.Requireable<string>;
        withClever: PropTypes.Requireable<boolean>;
    };
    static Size: {
        S: string;
        M: string;
        L: string;
        CUSTOM: string;
    };
    static defaultProps: {
        size: string;
    };
    render(): JSX.Element;
}
export {};
