import * as PropTypes from "prop-types";
import * as React from "react";
import { NavLink } from "./NavLink";
import { OneOrMany } from "../utils/types";
import "./NavGroup.less";
export interface Props {
    children: OneOrMany<React.ReactElement<NavLink>>;
    className?: string;
    icon: React.ReactElement;
    id: string;
    label: React.ReactNode;
    title?: string;
    _collapsed?: boolean;
    _onClick?: React.MouseEventHandler;
    _open?: boolean;
    _withActiveNavGroups?: boolean;
    _withTooltips?: boolean;
}
export declare const cssClass: {
    CONTAINER: string;
    OPEN: string;
};
export declare class NavGroup extends React.PureComponent<Props> {
    static propTypes: {
        children: PropTypes.Validator<any>;
        className: PropTypes.Requireable<string>;
        icon: PropTypes.Validator<PropTypes.ReactElementLike>;
        id: PropTypes.Validator<string>;
        label: PropTypes.Validator<PropTypes.ReactNodeLike>;
        title: PropTypes.Requireable<string>;
        _collapsed: PropTypes.Requireable<boolean>;
        _onClick: PropTypes.Requireable<(...args: any[]) => any>;
        _open: PropTypes.Requireable<boolean>;
        _withActiveNavGroups: PropTypes.Requireable<boolean>;
        _withTooltips: PropTypes.Requireable<boolean>;
    };
    render(): JSX.Element;
}
