import * as React from "react";
import * as PropTypes from "prop-types";
import "./Item.less";
export interface Props {
    children: React.ReactNode;
    className?: string;
    onClick?: React.MouseEventHandler<HTMLButtonElement | HTMLDivElement>;
    selected?: boolean;
}
export default class Item extends React.PureComponent<Props> {
    static propTypes: {
        children: PropTypes.Validator<PropTypes.ReactNodeLike>;
        className: PropTypes.Requireable<string>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        selected: PropTypes.Requireable<boolean>;
    };
    render(): JSX.Element;
}
