import * as React from "react";
import * as PropTypes from "prop-types";
import { Props as ModalProps } from "../Modal/Modal";
import "./MultiplePanelModals.less";
export interface Props {
    className?: string;
    componentArray: any[];
    closeModal: ModalProps["closeModal"];
    defaultOnClickLeftButton?: Function;
    defaultOnClickRightButton?: Function;
    height?: string | number;
    rightButtonDisabled?: boolean;
    startingPanel?: number;
    showStepNumber?: boolean;
}
interface State {
    currentPanel: number;
}
export declare const Classes: {
    STEP_NUMBER: string;
};
export declare class MultiplePanelModals extends React.Component<Props, State> {
    static propTypes: {
        className: PropTypes.Requireable<string>;
        componentArray: PropTypes.Validator<any[]>;
        closeModal: PropTypes.Validator<(...args: any[]) => any>;
        defaultOnClickLeftButton: PropTypes.Requireable<(...args: any[]) => any>;
        defaultOnClickRightButton: PropTypes.Requireable<(...args: any[]) => any>;
        height: PropTypes.Requireable<string>;
        rightButtonDisabled: PropTypes.Requireable<boolean>;
        startingPanel: PropTypes.Requireable<number>;
        showStepNumber: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        startingPanel: number;
        rightButtonDisabled: boolean;
        defaultOnClickLeftButton: () => void;
        defaultOnClickRightButton: () => void;
        showStepNumber: boolean;
    };
    constructor(props: Props);
    render(): JSX.Element;
}
export {};
