import * as React from "react";
import "./Radio.less";
export interface Props<IDType extends string = string, ValueType = any> {
    checked?: boolean;
    children: React.ReactNode;
    className?: string;
    disabled?: boolean;
    id: IDType;
    onSelect?: (id: IDType, value: ValueType) => void;
    tabIndex?: number;
    value?: ValueType;
    lang?: string;
}
/**
 * Single radio button input.
 * Usually used in a RadioGroup for providing a list of mutually-exclusive options to the user.
 */
export default class Radio<IDType extends string = string, ValueType = any> extends React.PureComponent<Props<IDType, ValueType>> {
    _element: any;
    _labelID: string;
    focus(): void;
    componentDidMount(): void;
    render(): JSX.Element;
    _onClick: () => void;
}
