import * as React from "react";
import "./ResourceTile.less";
export declare type IconSize = "small" | "medium" | "large";
export declare type IconOrientation = "landscape" | "portrait" | "unknown";
export declare const CssClasses: {
    ACTION: string;
    ACTION_BUTTON: string;
    CONTAINER: string;
    DRAGGABLE_ICON: string;
    LINK: string;
    ICON_CONTAINER: string;
    ICON: string;
    OVERLAYS: string;
    OVERLAY: string;
    TITLE_CONTAINER: string;
    TITLE_AND_NOTES: string;
    TITLE: string;
    NOTIFICATION: string;
    NOTES: string;
    ADDITIONAL_INFO: string;
};
export interface Action {
    content: React.ReactNode;
    href?: string;
    onClick?: () => void;
}
export interface Props {
    actions: [] | [Action] | [Action, Action];
    additionalInfo?: React.ReactNode;
    className?: string;
    draggable?: boolean;
    icon: {
        src: string;
    } | {
        node: React.ReactNode;
    };
    notes?: string;
    notify?: boolean;
    onClick?: (event?: React.MouseEvent) => void;
    openInSameTab: boolean;
    overlays?: React.ReactNode[];
    size: IconSize;
    title: string;
    url?: string;
}
interface State {
    iconOrientation: IconOrientation;
}
export declare class ResourceTile extends React.PureComponent<Props, State> {
    static defaultProps: Pick<Props, "actions" | "size" | "openInSameTab">;
    iconRef: React.RefObject<HTMLImageElement>;
    constructor(props: Props);
    determineIconOrientation(): void;
    renderIcon(): {};
    renderOverlays(): JSX.Element;
    render(): JSX.Element;
}
export {};
