import * as React from "react";
import { FormElementSize, FormElementRequirement } from "../utils/Forms";
import { Values } from "../utils/types";
import "./Select2.less";
declare type Option = {
    value: string;
    label: string;
    customLabel?: React.ReactNode;
};
export interface Props {
    className?: string;
    name: string;
    label: string;
    hideLabel?: boolean;
    options: Option[];
    clearable?: boolean;
    creatable?: boolean;
    requirement?: Values<typeof FormElementRequirement>;
    initialIsInError?: boolean;
    value: string;
    onChange: (value: string) => void;
    size?: Values<typeof FormElementSize>;
    placeholder?: string;
}
export declare const cssClass: {
    CONTAINER: string;
    INFO_ROW: string;
    INFO_ROW_LABEL_HIDDEN: string;
    INFO_REQUIREMENT: string;
    LABEL: string;
    LABEL_HIDDEN: string;
    SELECT_CONTAINER: string;
    SELECT_CONTAINER_FOCUSED: string;
    SELECT_CONTAINER_ERROR: string;
    SELECT_CONTAINER_DISABLED: string;
    INPUT: string;
    TRAILING_ELEMENT: string;
    ERROR_ICON: string;
    BUTTON_RESET: string;
    CLEAR_BUTTON: string;
    CARET_BUTTON: string;
    MENU_RESET: string;
    MENU_OPEN: string;
    MENU_OPTION: string;
    MENU_OPTION_HIGHLIGHTED: string;
    NO_OPTIONS_FOUND: string;
};
declare const Select2: React.FC<Props>;
export default Select2;
