import * as PropTypes from "prop-types";
import { PageRangeSize } from "./Table";
import "./Footer.less";
export interface Props {
    currentPage: number;
    onPageChange?: Function;
    numColumns: number;
    numPages: number;
    showLastPage?: boolean;
    isLoading?: boolean;
    lengthUnknown?: boolean;
    visiblePageRangeSize: PageRangeSize;
}
export declare const cssClass: {
    BUTTON_PAGE: string;
    BUTTON_PAGE_SELECTED: string;
    BUTTON_SCROLL: string;
    CELL: string;
    CONTAINER: string;
    ELLIPSIS: string;
    PAGE_NUMBERS: string;
    ROW: string;
    LOADING_CONTAINER: string;
    LOADING_PILL: string;
};
/**
 * Pagination footer for the Table component.
 * Only rendered if there are at least 2 pages of data available.
 */
declare function Footer({ currentPage, numColumns, numPages, onPageChange, showLastPage, isLoading, lengthUnknown, visiblePageRangeSize, }: Props): JSX.Element;
declare namespace Footer {
    var propTypes: {
        currentPage: (props: any, propName: any, componentName: any) => Error;
        onPageChange: PropTypes.Requireable<(...args: any[]) => any>;
        numColumns: PropTypes.Validator<number>;
        numPages: PropTypes.Validator<number>;
        showLastPage: PropTypes.Requireable<boolean>;
        isLoading: PropTypes.Requireable<boolean>;
        lengthUnknown: PropTypes.Requireable<boolean>;
        visiblePageRangeSize: PropTypes.Requireable<number>;
    };
    var defaultProps: {
        onPageChange: () => void;
        showLastPage: boolean;
    };
}
export default Footer;
