import * as React from "react";
import { Props as ButtonProps } from "../Button/Button";
import { ToastNotificationType } from "./ToastType";
import "./ToastNotification.less";
export interface ActionProps {
    href?: string;
    onClick?: ButtonProps["onClick"];
    text: string;
}
export interface Props {
    action: ActionProps;
    children: React.ReactNode;
    className?: string;
    onClose: ButtonProps["onClick"];
    showCloseButton?: boolean;
    type: ToastNotificationType;
    closeButtonAriaLabel?: string;
}
/**
 * A building block for the <ToastStack>. Renders an individual toast notification.
 */
export declare class ToastNotification extends React.PureComponent<Props> {
    static defaultProps: {
        showCloseButton: boolean;
    };
    render(): JSX.Element;
}
