import * as PropTypes from "prop-types";
import * as React from "react";
import "./WizardLayout.less";
export interface Props {
    className?: string;
    sections: any[];
    fullscreen?: boolean;
    headerImg?: any;
    helpContent?: React.ReactNode;
    hidePreviousStepButton?: boolean;
    nextStepButtonDisabled?: boolean;
    nextStepButtonText?: React.ReactNode;
    nextStepButtonTooltipText?: string;
    onNextStep: () => void;
    onPrevStep: () => void;
    prevStepButtonDisabled?: boolean;
    prevStepButtonText?: React.ReactNode;
    stepper: React.ReactNode;
    subtitle?: React.ReactNode;
    title: string;
}
/**
 * Layout to provide guidelines on how to implement a Wizard.
 */
export default class WizardLayout extends React.PureComponent<Props> {
    static propTypes: {
        className: PropTypes.Requireable<string>;
        fullscreen: PropTypes.Requireable<boolean>;
        headerImg: PropTypes.Requireable<PropTypes.ReactElementLike>;
        helpContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        hidePreviousStepButton: PropTypes.Requireable<boolean>;
        nextStepButtonDisabled: PropTypes.Requireable<boolean>;
        nextStepButtonText: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        nextStepButtonTooltipText: PropTypes.Requireable<string>;
        prevStepButtonDisabled: PropTypes.Requireable<boolean>;
        prevStepButtonText: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        onNextStep: PropTypes.Validator<(...args: any[]) => any>;
        onPrevStep: PropTypes.Validator<(...args: any[]) => any>;
        sections: PropTypes.Validator<PropTypes.InferProps<{
            title: PropTypes.Requireable<PropTypes.ReactNodeLike>;
            subtitle: PropTypes.Requireable<string>;
            content: PropTypes.Validator<PropTypes.ReactNodeLike>;
        }>[]>;
        stepper: PropTypes.Validator<PropTypes.ReactNodeLike>;
        subtitle: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        title: PropTypes.Validator<string>;
    };
    render(): JSX.Element;
    _onPrevStep: () => void;
    _onNextStep: () => void;
}
