import * as React from "react";
import * as PropTypes from "prop-types";
import { Values } from "../utils/types";
import ItemAlign from "./ItemAlign";
import "../less/flex.less";
export interface Props {
    alignSelf?: Values<typeof ItemAlign>;
    children?: React.ReactNode;
    className?: string;
    component?: any;
    [additionalProp: string]: any;
    grow?: boolean;
}
export declare const cssClass: {
    GROW: string;
    alignSelf: (value: string) => string;
};
declare function FlexItem({ alignSelf, children, className, component: Wrapper, grow, ...additionalProps }: Props): JSX.Element;
declare namespace FlexItem {
    var propTypes: {
        alignSelf: PropTypes.Requireable<Values<{
            readonly BASELINE: "baseline";
            readonly CENTER: "center";
            readonly END: "end";
            readonly START: "start";
            readonly STRETCH: "stretch";
        }>>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        className: PropTypes.Requireable<string>;
        component: PropTypes.Requireable<any>;
        grow: PropTypes.Requireable<boolean>;
    };
    var defaultProps: {
        component: string;
    };
}
export default FlexItem;
